Subject: [PATCH 3/9] irq: convert generic-chip to use irq_domain

From: [email-masked] (Rob Herring)
Date: Thu, 15 Dec 2011 08:01:46 -0600

On 12/15/2011 08:08 AM, Shawn Guo wrote:
> On Thu, Dec 15, 2011 at 07:39:37AM -0600, Rob Herring wrote:
>> On 12/14/2011 11:55 PM, Shawn Guo wrote:
>>> On Thu, Dec 15, 2011 at 01:25:20PM +0800, Shawn Guo wrote:
>>>> On Wed, Dec 14, 2011 at 09:28:52AM -0600, Rob Herring wrote:
>>>>> From: Rob Herring <[email-masked]>
>>>>>
>>>>> Add irq domain support to irq generic-chip. This enables users of
>>>>> generic-chip to support dynamic irq assignment needed for DT interrupt
>>>>> binding. Users must be converted to use irq_data.hwirq for determining
>>>>> local interrupt numbers rather than using the Linux irq number.
>>>>>
>>>>> irq_base is kept for now as there are a few users of it. Once they
>>>>> are converted to use the irq domain, it can be removed.
>>>>>
>>>>> Signed-off-by: Rob Herring <[email-masked]>
>>>>> Cc: Thomas Gleixner <[email-masked]>
>>>>> ---
>>>>
>>>> Tested-by: Shawn Guo <[email-masked]>
>>>>
>>> Sorry, I have to take that tag back after I correct my test setup.
>>> It does not work for imx5 TZIC case, because the following change
>>> I suggested before is missed.
>>>
>>> diff --git a/kernel/irq/irqdomain.c b/kernel/irq/irqdomain.c
>>> index eb763f7..2a2aac1 100644
>>> --- a/kernel/irq/irqdomain.c
>>> +++ b/kernel/irq/irqdomain.c
>>> @@ -39,7 +39,7 @@ void irq_domain_add(struct irq_domain *domain)
>>>                         return;
>>>                 }
>>>                 d->domain = domain;
>>> -               d->hwirq = hwirq;
>>> +               d->hwirq = hwirq - domain->hwirq_base;
>>
>> This is a problem. It entirely defeats the point of hwirq_base and it
>> would break the GIC. We need to fix this in the generic irq chip.
>>
> Actually I do not quite understand why we need to make the following
> change all over generic-chip.c.
> 
> -       u32 mask = 1 << (d->irq - gc->irq_base);
> +       u32 mask = 1 << d->hwirq;
> 
> Though d->irq is the Linux irq number, "d->irq - gc->irq_base" is
> really just what we need here.

That's assuming a linear mapping between the irq and hwirq. What if we
start allocating irq_descs on demand within a domain? Then there would
be no way to convert.

Rob